/* General mozilla system functions. */

/* Yes, get the currently focused document. */
function getFocusedDoc (doc) {
    //Quite messy because javascript sucks or I just did not get it!
    if (doc == undefined || doc == null)
	doc = document;
    try {
	if (doc instanceof XULDocument) {
	    var focusedWin = doc.commandDispatcher.focusedWindow;
	    var curDoc = focusedWin.document;
	    if (curDoc instanceof XULDocument || curDoc == null) {
		//curDoc = window.frames[0].document;
		curDoc = doc.getElementById("content").contentDocument;
		//curDoc = _content.document;
	    }
	} else {
	    curDoc = doc;
	}
    } catch(e) {
	if (content)
	    curDoc = content.document;
    	myalert("getFocusedDoc " + e + curDoc, "getfocusedDoc");
    }
    return curDoc;
}

/***********************************************************************/
/***********************************************************************/

/* Return mozilla preference handler. */
function getPrefer() {
    const PREFCIID = "@mozilla.org/preferences-service;1";
    try {
    var PREFIFACE = Components.interfaces.nsIPrefBranch;
    var prefs = Components.classes[PREFCIID].getService(PREFIFACE);
    } catch(e) {myalert('getPrefer: ' + e + prefs, 'getprefer');}
    return prefs;
}
/* tongwen preferences handling object. */
var tongwen_options = {
  prefs: getPrefer(),

  /* Get option, 2nd argument can force set if not exist. */
  get: function (ppath)
  {
    var ret;
    try {
      var ptype = this.prefs.getPrefType(ppath);
      switch(ptype) {
        case this.prefs.PREF_STRING:
	  ret = this.prefs.getCharPref(ppath); 
	  break;
	case this.prefs.PREF_INT:
	  ret = this.prefs.getIntPref(ppath);
	  break;
	case this.prefs.PREF_BOOL:
	  ret = this.prefs.getBoolPref(ppath);
	  break;
	case this.prefs.PREF_INVALID:
	  if (arguments.length == 1)
	    ret = null;
	  else if (arguments.length==2) {
	    this.set(ppath, arguments[1]);
	    ret = arguments[1];
	  }
	  break;
      }
    } catch(e) {
      if (arguments.length == 1)
        ret = null;
      else if (arguments.length==2) {
	this.set(ppath, arguments[1]);
	ret = arguments[1];
      }
    }
    return ret;
  },

  set: function (ppath, value)
  {
    try {
	var vtype = typeof value;
	switch(vtype) {
	  case "string":
	    this.prefs.setCharPref(ppath, value);
	    break;
	  case "number":
	    this.prefs.setIntPref(ppath, value);
	    break;
	  case "boolean":
	    this.prefs.setBoolPref(ppath, value);
	    break;
	 }
     } catch(e) {alert(e);}
   },
   
  get_auto_convert: function ()
  {
      return this.get("tongwentang.autoconvert.chineseCharset"); 
  },
  set_auto_convert: function (stat)
  {
      this.set("tongwentang.autoconvert.chineseCharset", stat);
  },

  /* Debug option. */
  get_debug: function ()
  {
      return this.get("tongwentang.debug", DEBUG); 
  },

  set_debug: function (stat)
  {
      this.set("tongwentang.debug", stat);
  },

  add_observe: function(listener)
   {
    try{
       var pbi = this.prefs.QueryInterface(
	       Components.interfaces.nsIPrefBranchInternal);
       pbi.addObserver(listener.prefpath, listener, false);
       
    } catch(e) {alert(e)}
   },
}

/* Sync with preference change. */
function genericObserve(aSubject, aTopic, aPrefPath)
{
    if (aTopic == "nsPref:changed" && aPrefPath == this.prefpath)
	this.updatePref();
}

/* A generic preference monitoring object constructor. */
function watchPref(prefpath, updateFunc) {
    this.prefpath = prefpath;
    this.observe = genericObserve;
    this.updatePref = updateFunc;
    return this;
}

/* Watch DEBUG. */
var watchDebug = {
  prefpath: "tongwentang.debug",
  observe: genericObserve,
  updatePref: function () {
    var stat = tongwen_options.get(this.prefpath);
    DEBUG = (stat != null) ? stat:DEBUG;
  },
}
try {
DEBUG=tongwen_options.get_debug();
} catch(e) { alert(e); }

tongwen_options.add_observe(watchDebug);

/* Watch ZHENCODINGONLY. */
var watchZhEncodingOnly = {
  prefpath: "tongwentang.autoconvert.chineseEncodingOnly",
  observe: genericObserve,
  updatePref: function () {
    var stat = tongwen_options.get(this.prefpath);
    ZHENCODINGONLY = (stat != null) ? stat:false;
  },
}

try {
ZHENCODINGONLY=tongwen_options.get(watchZhEncodingOnly.prefpath, ZHENCODINGONLY);
tongwen_options.add_observe(watchZhEncodingOnly);
}catch(e){myalert(e);}

/* Watch OPPCHARSETONLY. */
var watchOppCharsetOnly = {
  prefpath: "tongwentang.autoconvert.oppositeCharsetOnly",
  observe: genericObserve,
  updatePref: function () {
    var stat = tongwen_options.get(this.prefpath);
    OPPCHARSETONLY = (stat != null) ? stat:false;
  },
}

try {
OPPCHARSETONLY=tongwen_options.get(watchOppCharsetOnly.prefpath, OPPCHARSETONLY);
tongwen_options.add_observe(watchOppCharsetOnly);
}catch(e){alert(e);}

/* Remove all options. */
// tongwen_options.prefs.deleteBranch('tongwentang.debug');
// tongwen_options.prefs.deleteBranch('tongwentang.chineseCharsetOnly');
// tongwen_options.prefs.deleteBranch('tongwentang.autoconvert');
